'
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
'    Name: Installed_db
'    Author: Wuerth Phoenix S.R.L.
'    Website: http://neteye-blog.com
'    Version: 1.0 (29/10/2014)
'

Const HKLM = &H80000002 'HKEY_LOCAL_MACHINE 
Const HKEY_USERS = &H80000003

strComputer = "." 
Set objReg = GetObject("winmgmts:{impersonationLevel=impersonate}//" & strComputer & "/root/default:StdRegProv") 
Set objFSO = CreateObject ("Scripting.FileSystemObject")
'Set objFile = objFSO.CreateTextFile("output.txt", True)
Set objFile = objFSO.GetStandardStream(1)





Sub Installed(HKLM, strKey, Search)
	strEntry1 = "DisplayName" 
	strEntry2 = "DisplayVersion" 
	strEntry3 = "InstallLocation" 
	strEntry4 = "Publisher" 

	objReg.EnumKey HKLM, strKey, arrSubkeys 

    If Not IsNull(arrSubkeys) Then
		For Each strSubkey In arrSubkeys 
			intRet = objReg.GetStringValue(HKLM, strKey & strSubkey, strEntry1, strValue1) 
			If intRet = 0 AND strValue1 <> "" AND strValue1 = Search Then   
			    objFile.WriteLine "<SOFTWARES>"
				objFile.WriteLine "<NAME>" & strValue1 & "</NAME>"
				objFile.WriteLine "<COMMENT>" & strKey & "</COMMENT>"
				objReg.GetStringValue HKLM, strKey & strSubkey, strEntry2, strValue2 
				If strValue2 <> "" Then 
					objFile.WriteLine "<VERSION>" & strValue2 & "</VERSION>"
				End If 
				objReg.GetStringValue HKLM, strKey & strSubkey, strEntry3, strValue3 
				If strValue3 <> "" Then 
					objFile.WriteLine "<INSTALLLOCATION>" & strValue3 & "</INSTALLLOCATION>" 
				End If 
				objReg.GetStringValue HKLM, strKey & strSubkey, strEntry4, strValue4 
				If strValue4 <> "" Then
					objFile.WriteLine "<PUBLISHER>" & strValue4 & "</PUBLISHER>"
				End If 	
				objFile.WriteLine "</SOFTWARES>"
			End If 
		Next 
	End If
End Sub	

objReg.EnumKey HKEY_USERS, "", sidList
For Each sid In sidList
  Call Installed(HKEY_USERS, sid & "\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\","Google Chrome")
  Call Installed(HKEY_USERS, sid & "\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\","Google Chrome")
   
  Call Installed(HKEY_USERS, sid & "\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\","Dropbox")
  Call Installed(HKEY_USERS, sid & "\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\","Dropbox")
   
Next

 Call Installed(HKLM, "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\","Google Chrome")
 Call Installed(HKLM, "SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\","Google Chrome")

 Call Installed(HKLM, "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\","Dropbox")
 Call Installed(HKLM, "SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\","Dropbox")

